define("activesync/folder", [ "rdcommon/log", "../date", "../syncbase", "../allback", "../db/mail_rep", "activesync/codepages/AirSync", "activesync/codepages/AirSyncBase", "activesync/codepages/ItemEstimate", "activesync/codepages/Email", "activesync/codepages/ItemOperations", "safe-base64", "mimetypes", "module", "require", "exports" ], function(e, t, n, i, a, o, r, s, c, l, d, p, u, h, f) {
    function m() {
        y = o.Enums.FilterType, x = {
            auto: null,
            "1d": y.OneDayBack,
            "3d": y.ThreeDaysBack,
            "1w": y.OneWeekBack,
            "2w": y.TwoWeeksBack,
            "1m": y.OneMonthBack,
            all: y.NoFilter
        }, b = {
            0: "all messages",
            1: "one day",
            2: "three days",
            3: "one week",
            4: "two weeks",
            5: "one month"
        };
    }
    function g(e, t, n) {
        return function() {
            var i = Array.slice(arguments), a = i[e], o = this;
            h([ "wbxml", "addressparser", "../mailchew" ], function(e, r, s) {
                w || (w = e, S = r.parse.bind(r), k = s, m()), o._account.withConnection(a, function() {
                    t.apply(o, i);
                }, n);
            });
        };
    }
    function v(e, t, n) {
        this._account = e, this._storage = t, this._LOG = A.ActiveSyncFolderConn(this, n, t.folderId), 
        this.folderMeta = t.folderMeta, this.syncKey || (this.syncKey = "0");
    }
    function _(e, t, n) {
        this._account = e, this.folderStorage = t, this._LOG = A.ActiveSyncFolderSyncer(this, n, t.folderId), 
        this.folderConn = new v(e, t, this._LOG);
    }
    var y, x, b, w, S, k, I = 512, T = 50;
    v.prototype = {
        get syncKey() {
            return this.folderMeta.syncKey;
        },
        set syncKey(e) {
            return this.folderMeta.syncKey = e;
        },
        get serverId() {
            return this.folderMeta.serverId;
        },
        get filterType() {
            var e = this._account.accountDef.syncRange;
            if (x.hasOwnProperty(e)) {
                var t = x[e];
                return t ? t : this.folderMeta.filterType;
            }
            return console.warn("Got an invalid syncRange (" + e + ") using three days back instead"), 
            o.Enums.FilterType.ThreeDaysBack;
        },
        _getSyncKey: g(1, function(e, t) {
            var n = this, i = this._account, a = o.Tags, r = new w.Writer("1.3", 1, "UTF-8");
            r.stag(a.Sync).stag(a.Collections).stag(a.Collection), i.conn.currentVersion.lt("12.1") && r.tag(a.Class, "Email"), 
            r.tag(a.SyncKey, "0").tag(a.CollectionId, this.serverId).stag(a.Options).tag(a.FilterType, e).etag().etag().etag().etag(), 
            i.conn.postCommand(r, function(e, o) {
                if (e) return console.error(e), i._reportErrorIfNecessary(e), t("unknown"), void 0;
                n.syncKey = "0";
                var r = new w.EventParser();
                r.addEventListener([ a.Sync, a.Collections, a.Collection, a.SyncKey ], function(e) {
                    n.syncKey = e.children[0].textContent;
                }), r.onerror = function() {}, r.run(o), "0" === n.syncKey ? (console.error("Unable to get sync key for folder"), 
                t("unknown")) : t();
            });
        }),
        _getItemEstimate: g(1, function(e, t) {
            var n = s.Tags, i = o.Tags, a = this._account, r = new w.Writer("1.3", 1, "UTF-8");
            r.stag(n.GetItemEstimate).stag(n.Collections).stag(n.Collection), this._account.conn.currentVersion.gte("14.0") ? r.tag(i.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).stag(i.Options).tag(i.FilterType, e).etag() : this._account.conn.currentVersion.gte("12.0") ? r.tag(n.CollectionId, this.serverId).tag(i.FilterType, e).tag(i.SyncKey, this.syncKey) : r.tag(n.Class, "Email").tag(i.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).tag(i.FilterType, e), 
            r.etag(n.Collection).etag(n.Collections).etag(n.GetItemEstimate), a.conn.postCommand(r, function(e, i) {
                if (e) return console.error(e), a._reportErrorIfNecessary(e), t("unknown"), void 0;
                var o, r, c = new w.EventParser(), l = [ n.GetItemEstimate, n.Response ];
                c.addEventListener(l.concat(n.Status), function(e) {
                    o = e.children[0].textContent;
                }), c.addEventListener(l.concat(n.Collection, n.Estimate), function(e) {
                    r = parseInt(e.children[0].textContent, 10);
                });
                try {
                    c.run(i);
                } catch (d) {
                    return console.error("Error parsing GetItemEstimate response", d, "\n", d.stack), 
                    t("unknown"), void 0;
                }
                o !== s.Enums.Status.Success ? (console.error("Error getting item estimate:", o), 
                t("unknown")) : t(null, r);
            });
        }),
        _inferFilterType: g(0, function(e) {
            var t = this, n = o.Enums.FilterType, i = function(i, a) {
                t._getSyncKey(i, function(o) {
                    return o ? (e("unknown"), void 0) : (t._getItemEstimate(i, function(t, i) {
                        return t ? (e(null, n.ThreeDaysBack), void 0) : (a(i), void 0);
                    }), void 0);
                });
            };
            i(n.TwoWeeksBack, function(a) {
                var o, r = a / 14;
                if (0 > a) o = n.ThreeDaysBack; else if (r >= T) o = n.OneDayBack; else if (3 * r >= T) o = n.ThreeDaysBack; else if (7 * r >= T) o = n.OneWeekBack; else if (14 * r >= T) o = n.TwoWeeksBack; else {
                    if (!(30 * r >= T)) return i(n.NoFilter, function(i) {
                        var a;
                        i > T ? (a = n.OneMonthBack, t.syncKey = "0") : a = n.NoFilter, t._LOG.inferFilterType(a), 
                        e(null, a);
                    }), void 0;
                    o = n.OneMonthBack;
                }
                o !== n.TwoWeeksBack && (t.syncKey = "0"), t._LOG.inferFilterType(o), e(null, o);
            });
        }),
        _enumerateFolderChanges: g(0, function(e, t) {
            var n = this, i = this._storage;
            if (!this.filterType) return this._inferFilterType(function(i, a) {
                return i ? (e("unknown"), void 0) : (console.log("We want a filter of", b[a]), n.folderMeta.filterType = a, 
                n._enumerateFolderChanges(e, t), void 0);
            }), void 0;
            if ("0" === this.syncKey) return this._getSyncKey(this.filterType, function(i) {
                return i ? (e("aborted"), void 0) : (n._enumerateFolderChanges(e, t), void 0);
            }), void 0;
            var a = o.Tags, s = o.Enums;
            r.Tags, r.Enums;
            var c;
            0 === this._account._syncsInProgress++ && this._account._lastSyncKey === this.syncKey && this._account._lastSyncFilterType === this.filterType && this._account._lastSyncResponseWasEmpty ? c = a.Sync : (c = new w.Writer("1.3", 1, "UTF-8"), 
            c.stag(a.Sync).stag(a.Collections).stag(a.Collection), this._account.conn.currentVersion.lt("12.1") && c.tag(a.Class, "Email"), 
            c.tag(a.SyncKey, this.syncKey).tag(a.CollectionId, this.serverId).tag(a.GetChanges).stag(a.Options).tag(a.FilterType, this.filterType), 
            this._account.conn.currentVersion.lte("12.0") && c.tag(a.MIMESupport, s.MIMESupport.Never).tag(a.Truncation, s.MIMETruncation.TruncateAll), 
            c.etag().etag().etag().etag()), this._account.conn.postCommand(c, function(o, r) {
                var c, l = [], d = [], p = [], u = !1;
                if (n._account._syncsInProgress--, o) return console.error("Error syncing folder:", o), 
                n._account._reportErrorIfNecessary(o), e("aborted"), void 0;
                if (n._account._lastSyncKey = n.syncKey, n._account._lastSyncFilterType = n.filterType, 
                !r) return console.log("Sync completed with empty response"), n._account._lastSyncResponseWasEmpty = !0, 
                e(null, l, d, p), void 0;
                n._account._lastSyncResponseWasEmpty = !1;
                var h = new w.EventParser(), f = [ a.Sync, a.Collections, a.Collection ];
                h.addEventListener(f.concat(a.SyncKey), function(e) {
                    n.syncKey = e.children[0].textContent;
                }), h.addEventListener(f.concat(a.Status), function(e) {
                    c = e.children[0].textContent;
                }), h.addEventListener(f.concat(a.MoreAvailable), function() {
                    u = !0;
                }), h.addEventListener(f.concat(a.Commands, [ [ a.Add, a.Change ] ]), function(e) {
                    var t, o;
                    for (var r in Iterator(e.children)) {
                        var s = r[1];
                        switch (s.tag) {
                          case a.ServerId:
                            t = s.children[0].textContent;
                            break;

                          case a.ApplicationData:
                            try {
                                o = n._parseMessage(s, e.tag === a.Add, i);
                            } catch (c) {
                                return console.error("Failed to parse a message:", c, "\n", c.stack), void 0;
                            }
                        }
                    }
                    o.header.srvid = t;
                    var p = e.tag === a.Add ? l : d;
                    p.push(o);
                }), h.addEventListener(f.concat(a.Commands, [ [ a.Delete, a.SoftDelete ] ]), function(e) {
                    var t;
                    for (var n in Iterator(e.children)) {
                        var i = n[1];
                        switch (i.tag) {
                          case a.ServerId:
                            t = i.children[0].textContent;
                        }
                    }
                    p.push(t);
                });
                try {
                    h.run(r);
                } catch (m) {
                    return console.error("Error parsing Sync response:", m, "\n", m.stack), e("unknown"), 
                    void 0;
                }
                c === s.Status.Success ? (console.log("Sync completed: added " + l.length + ", changed " + d.length + ", deleted " + p.length), 
                e(null, l, d, p, u), u && n._enumerateFolderChanges(e, t)) : c === s.Status.InvalidSyncKey ? (console.warn("ActiveSync had a bad sync key"), 
                e("badkey")) : (console.error("Something went wrong during ActiveSync syncing and we got a status of " + c), 
                e("unknown"));
            }, null, null, function(e, n) {
                n || (n = Math.max(1e6, e)), t(.1 + .7 * e / n);
            });
        }, "aborted"),
        _parseMessage: function(e, t, n) {
            var i, o, s, l = c.Tags, d = r.Tags, u = r.Enums;
            if (t) {
                var h = n._issueNewHeaderId();
                i = {
                    id: h,
                    srvid: null,
                    suid: n.folderId + "/" + h,
                    guid: "",
                    author: null,
                    to: null,
                    cc: null,
                    bcc: null,
                    replyTo: null,
                    date: null,
                    flags: [],
                    hasAttachments: !1,
                    subject: null,
                    snippet: null
                }, o = {
                    date: null,
                    size: 0,
                    attachments: [],
                    relatedParts: [],
                    references: null,
                    bodyReps: null
                }, s = function(e, t) {
                    t && i.flags.push(e);
                };
            } else i = {
                flags: [],
                mergeInto: function(e) {
                    for (var t in Iterator(this.flags)) {
                        var n = t[1];
                        if (n[1]) e.flags.push(n[0]); else {
                            var i = e.flags.indexOf(n[0]);
                            -1 !== i && e.flags.splice(i, 1);
                        }
                    }
                    var a = [ "mergeInto", "suid", "srvid", "guid", "id", "flags" ];
                    for (var t in Iterator(this)) {
                        var o = t[0], r = t[1];
                        -1 === a.indexOf(o) && (e[o] = r);
                    }
                }
            }, o = {
                mergeInto: function(e) {
                    for (var t in Iterator(this)) {
                        var n = t[0], i = t[1];
                        "mergeInto" !== n && (e[n] = i);
                    }
                }
            }, s = function(e, t) {
                i.flags.push([ e, t ]);
            };
            var f, m;
            for (var g in Iterator(e.children)) {
                var v = g[1], _ = v.children.length ? v.children[0].textContent : null;
                switch (v.tag) {
                  case l.Subject:
                    i.subject = _;
                    break;

                  case l.From:
                    i.author = S(_)[0] || null;
                    break;

                  case l.To:
                    i.to = S(_);
                    break;

                  case l.Cc:
                    i.cc = S(_);
                    break;

                  case l.ReplyTo:
                    i.replyTo = S(_);
                    break;

                  case l.DateReceived:
                    o.date = i.date = new Date(_).valueOf();
                    break;

                  case l.Read:
                    s("\\Seen", "1" === _);
                    break;

                  case l.Flag:
                    for (var y in Iterator(v.children)) {
                        var x = y[1];
                        x.tag === l.Status && s("\\Flagged", "0" !== x.children[0].textContent);
                    }
                    break;

                  case d.Body:
                    for (var y in Iterator(v.children)) {
                        var x = y[1];
                        switch (x.tag) {
                          case d.Type:
                            var b = x.children[0].textContent;
                            b === u.Type.HTML ? f = "html" : (b !== u.Type.PlainText && console.warn("A message had a strange body type:", b), 
                            f = "plain");
                            break;

                          case d.EstimatedDataSize:
                            m = x.children[0].textContent;
                        }
                    }
                    break;

                  case l.BodySize:
                    f = "plain", m = _;
                    break;

                  case d.Attachments:
                  case l.Attachments:
                    for (var y in Iterator(v.children)) {
                        var w = y[1];
                        if (w.tag === d.Attachment || w.tag === l.Attachment) {
                            var k = {
                                name: null,
                                contentId: null,
                                type: null,
                                part: null,
                                encoding: null,
                                sizeEstimate: null,
                                file: null
                            }, I = !1;
                            for (var T in Iterator(w.children)) {
                                var A, E, O = T[1], M = O.children.length ? O.children[0].textContent : null;
                                switch (O.tag) {
                                  case d.DisplayName:
                                  case l.DisplayName:
                                    k.name = M, A = k.name.lastIndexOf("."), E = A > 0 ? k.name.substring(A + 1).toLowerCase() : "", 
                                    k.type = p.detectMimeType(E);
                                    break;

                                  case d.FileReference:
                                  case l.AttName:
                                    k.part = M;
                                    break;

                                  case d.EstimatedDataSize:
                                  case l.AttSize:
                                    k.sizeEstimate = parseInt(M, 10);
                                    break;

                                  case d.ContentId:
                                    k.contentId = M;
                                    break;

                                  case d.IsInline:
                                    I = "1" === M;
                                    break;

                                  case d.FileReference:
                                  case l.Att0Id:
                                    k.part = O.children[0].textContent;
                                }
                            }
                            I ? o.relatedParts.push(a.makeAttachmentPart(k)) : o.attachments.push(a.makeAttachmentPart(k));
                        }
                    }
                    i.hasAttachments = o.attachments.length > 0;
                }
            }
            return t ? (o.bodyReps = [ a.makeBodyPart({
                type: f,
                sizeEstimate: m,
                amountDownloaded: 0,
                isDownloaded: !1
            }) ], {
                header: a.makeHeaderInfo(i),
                body: a.makeBodyInfo(o)
            }) : {
                header: i,
                body: o
            };
        },
        downloadBodies: function(e, t, n) {
            if (this._account.conn.currentVersion.lt("12.0")) return this._syncBodies(e, n);
            for (var a = 0, o = i.latch(), r = 0; r < e.length; r++) {
                var s = e[r];
                s && null === s.snippet && (a++, this.downloadBodyReps(s, t, o.defer(s.suid)));
            }
            o.then(function(e) {
                n(i.extractErrFromCallbackArgs(e), a);
            });
        },
        downloadBodyReps: g(1, function(e, t, n) {
            var i = this, a = this._account;
            if (a.conn.currentVersion.lt("12.0")) return this._syncBodies([ e ], n);
            "function" == typeof t && (n = t, t = null), t = t || {};
            var s = l.Tags, c = l.Enums, d = o.Tags;
            o.Enums;
            var p = r.Tags, u = r.Enums.Type, h = function(o) {
                if (!o) return n("unknown");
                var r, l = o.bodyReps[0], h = "html" === l.type ? u.HTML : u.PlainText;
                t.maximumBytesToFetch < l.sizeEstimate && (h = u.PlainText, r = I);
                var f = new w.Writer("1.3", 1, "UTF-8");
                f.stag(s.ItemOperations).stag(s.Fetch).tag(s.Store, "Mailbox").tag(d.CollectionId, i.serverId).tag(d.ServerId, e.srvid).stag(s.Options).stag(s.Schema).tag(p.Body).etag().stag(p.BodyPreference).tag(p.Type, h), 
                r && f.tag(p.TruncationSize, r), f.etag().etag().etag().etag(), a.conn.postCommand(f, function(t, l) {
                    if (t) return console.error(t), a._reportErrorIfNecessary(t), n("unknown"), void 0;
                    var d, u, h = new w.EventParser();
                    h.addEventListener([ s.ItemOperations, s.Status ], function(e) {
                        d = e.children[0].textContent;
                    }), h.addEventListener([ s.ItemOperations, s.Response, s.Fetch, s.Properties, p.Body, p.Data ], function(e) {
                        u = e.children[0].textContent;
                    });
                    try {
                        h.run(l);
                    } catch (f) {
                        return n("unknown");
                    }
                    return d !== c.Status.Success ? n("unknown") : (i._updateBody(e, o, u, !!r, n), 
                    void 0);
                });
            };
            this._storage.getMessageBody(e.suid, e.date, h);
        }),
        _syncBodies: function(e, t) {
            var n = o.Tags, a = o.Enums, r = c.Tags, s = this, l = this._account, d = new w.Writer("1.3", 1, "UTF-8");
            d.stag(n.Sync).stag(n.Collections).stag(n.Collection).tag(n.Class, "Email").tag(n.SyncKey, this.syncKey).tag(n.CollectionId, this.serverId).stag(n.Options).tag(n.MIMESupport, a.MIMESupport.Never).etag().stag(n.Commands);
            for (var p = 0; p < e.length; p++) d.stag(n.Fetch).tag(n.ServerId, e[p].srvid).etag();
            d.etag().etag().etag().etag(), l.conn.postCommand(d, function(o, c) {
                if (o) return console.error(o), l._reportErrorIfNecessary(o), t("unknown"), void 0;
                var d = i.latch(), p = 0, u = new w.EventParser(), h = [ n.Sync, n.Collections, n.Collection ];
                u.addEventListener(h.concat(n.SyncKey), function(e) {
                    s.syncKey = e.children[0].textContent;
                }), u.addEventListener(h.concat(n.Status), function(e) {
                    var t = e.children[0].textContent;
                    t !== a.Status.Success && d.defer("status")("unknown");
                }), u.addEventListener(h.concat(n.Responses, n.Fetch, n.ApplicationData, r.Body), function(t) {
                    var n = e[p++], i = t.children[0].textContent, a = d.defer(n.suid);
                    s._storage.getMessageBody(n.suid, n.date, function(e) {
                        s._updateBody(n, e, i, !1, a);
                    });
                }), u.run(c), d.then(function(e) {
                    t(i.extractErrFromCallbackArgs(e));
                });
            });
        },
        _activeSyncHeaderIsSeen: function(e) {
            for (var t = 0; t < e.flags.length; t++) if ("\\Seen" === e.flags[t][0] && e.flags[t][1]) return !0;
            return !1;
        },
        _updateBody: function(e, t, n, a, o) {
            var r = t.bodyReps[0];
            n = n.replace(/\r/g, "");
            var s = a ? "plain" : r.type, c = k.processMessageContent(n, s, !a, !0, this._LOG);
            e.snippet = c.snippet, r.isDownloaded = !a, r.amountDownloaded = n.length, a || (r.content = c.content);
            var l = {
                changeDetails: {
                    bodyReps: [ 0 ]
                }
            }, d = i.latch();
            this._storage.updateMessageHeader(e.date, e.id, !1, e, t, d.defer("header")), this._storage.updateMessageBody(e, t, {}, l, d.defer("body")), 
            d.then(o.bind(null, null, t, !1));
        },
        sync: g(1, function(e, t, a) {
            var o = this, r = 0, s = 0, c = 0;
            this._LOG.sync_begin(null, null, null);
            var l = this;
            this._enumerateFolderChanges(function(a, d, p, u, h) {
                var f = o._storage;
                if ("badkey" === a) return o._account._recreateFolder(f.folderId, function() {
                    o._storage = null, o._LOG.sync_end(null, null, null);
                }), void 0;
                if (a) return o._LOG.sync_end(null, null, null), t(a), void 0;
                var m = i.latch();
                for (var g in Iterator(d)) {
                    var v = g[1];
                    f.hasMessageWithServerId(v.header.srvid) || (f.addMessageHeader(v.header, v.body, m.defer()), 
                    f.addMessageBody(v.header, v.body, m.defer()), r++);
                }
                for (var g in Iterator(p)) {
                    var v = g[1];
                    f.hasMessageWithServerId(v.header.srvid) && (f.updateMessageHeaderByServerId(v.header.srvid, !0, function(e, t) {
                        return !l._activeSyncHeaderIsSeen(t) && l._activeSyncHeaderIsSeen(e.header) ? f.folderMeta.unreadCount-- : l._activeSyncHeaderIsSeen(t) && !l._activeSyncHeaderIsSeen(e.header) && f.folderMeta.unreadCount++, 
                        e.header.mergeInto(t), !0;
                    }.bind(null, v), null, m.defer()), s++);
                }
                for (var g in Iterator(u)) {
                    var _ = g[1];
                    f.hasMessageWithServerId(_) && (f.deleteMessageByServerId(_, m.defer()), c++);
                }
                if (!h) {
                    var y = r + s + c;
                    m.then(function() {
                        o._LOG.sync_end(r, s, c), f.markSyncRange(n.OLDEST_SYNC_DATE, e, "XXX", e), t(null, null, y);
                    });
                }
            }, a);
        }),
        performMutation: g(1, function(e, t) {
            var n = this, i = o.Tags, a = this._account, r = new w.Writer("1.3", 1, "UTF-8");
            r.stag(i.Sync).stag(i.Collections).stag(i.Collection), a.conn.currentVersion.lt("12.1") && r.tag(i.Class, "Email"), 
            r.tag(i.SyncKey, this.syncKey).tag(i.CollectionId, this.serverId).tag(i.DeletesAsMoves, "trash" === this.folderMeta.type ? "0" : "1").tag(i.GetChanges, "0").stag(i.Commands);
            try {
                e(r);
            } catch (s) {
                return console.error("Exception in performMutation callee:", s, "\n", s.stack), 
                t("unknown"), void 0;
            }
            r.etag(i.Commands).etag(i.Collection).etag(i.Collections).etag(i.Sync), a.conn.postCommand(r, function(e, r) {
                if (e) return console.error("postCommand error:", e), a._reportErrorIfNecessary(e), 
                t("unknown"), void 0;
                var s, c, l = new w.EventParser(), d = [ i.Sync, i.Collections, i.Collection ];
                l.addEventListener(d.concat(i.SyncKey), function(e) {
                    s = e.children[0].textContent;
                }), l.addEventListener(d.concat(i.Status), function(e) {
                    c = e.children[0].textContent;
                });
                try {
                    l.run(r);
                } catch (p) {
                    return console.error("Error parsing Sync response:", p, "\n", p.stack), t("unknown"), 
                    void 0;
                }
                c === o.Enums.Status.Success ? (n.syncKey = s, t && t(null)) : (console.error("Something went wrong during ActiveSync syncing and we got a status of " + c), 
                t("status:" + c));
            });
        }),
        downloadMessageAttachments: g(2, function(e, t, n) {
            var i = this, a = l.Tags, o = l.Enums.Status, s = r.Tags, c = new w.Writer("1.3", 1, "UTF-8");
            c.stag(a.ItemOperations);
            for (var p in Iterator(t)) {
                var u = p[1];
                c.stag(a.Fetch).tag(a.Store, "Mailbox").tag(s.FileReference, u.part).etag();
            }
            c.etag(), this._account.conn.postCommand(c, function(e, r) {
                if (e) return console.error("postCommand error:", e), i._account._reportErrorIfNecessary(e), 
                n("unknown"), void 0;
                var c, l = {}, p = new w.EventParser();
                p.addEventListener([ a.ItemOperations, a.Status ], function(e) {
                    c = e.children[0].textContent;
                }), p.addEventListener([ a.ItemOperations, a.Response, a.Fetch ], function(e) {
                    var t = null, n = {};
                    for (var i in Iterator(e.children)) {
                        var o = i[1];
                        switch (o.tag) {
                          case a.Status:
                            n.status = o.children[0].textContent;
                            break;

                          case s.FileReference:
                            t = o.children[0].textContent;
                            break;

                          case a.Properties:
                            var r = null, c = null;
                            for (var p in Iterator(o.children)) {
                                var u = p[1], h = u.children[0].textContent;
                                switch (u.tag) {
                                  case s.ContentType:
                                    r = h;
                                    break;

                                  case a.Data:
                                    c = d.decode(h);
                                }
                            }
                            r && c && (n.data = new Blob([ c ], {
                                type: r
                            }));
                        }
                        t && (l[t] = n);
                    }
                }), p.run(r);
                var u = c !== o.Success ? "unknown" : null, h = [];
                for (var f in Iterator(t)) {
                    var m = f[1];
                    l.hasOwnProperty(m.part) && l[m.part].status === o.Success ? h.push(l[m.part].data) : (u = "unknown", 
                    h.push(null));
                }
                n(u, h);
            });
        })
    }, f.ActiveSyncFolderSyncer = _, _.prototype = {
        get syncable() {
            return null !== this.folderConn.serverId;
        },
        get canGrowSync() {
            return !1;
        },
        initialSync: function(e, n, i, a, o) {
            i("sync", !0), this.folderConn.sync(t.NOW(), this.onSyncCompleted.bind(this, a, !0), o);
        },
        refreshSync: function(e, n, i, a, o, r, s) {
            this.folderConn.sync(t.NOW(), this.onSyncCompleted.bind(this, r, !1), s);
        },
        growSync: function() {
            return !1;
        },
        onSyncCompleted: function(e, t, i, a, o) {
            var r = this.folderStorage;
            console.log("Sync Completed!", o, "messages synced"), i || r.markSyncedToDawnOfTime(), 
            this._account.__checkpointSyncCompleted(function() {
                i ? e(i) : t ? (r._curSyncSlice.ignoreHeaders = !1, r._curSyncSlice.waitingOnData = "db", 
                r.getMessagesInImapDateRange(0, null, n.INITIAL_FILL_SIZE, n.INITIAL_FILL_SIZE, r.onFetchDBHeaders.bind(r, r._curSyncSlice, !1, e, null))) : e(i);
            });
        },
        allConsumersDead: function() {},
        shutdown: function() {
            this.folderConn.shutdown(), this._LOG.__die();
        }
    };
    var A = f.LOGFAB = e.register(u, {
        ActiveSyncFolderConn: {
            type: e.CONNECTION,
            subtype: e.CLIENT,
            events: {
                inferFilterType: {
                    filterType: !1
                }
            },
            asyncJobs: {
                sync: {
                    newMessages: !0,
                    changedMessages: !0,
                    deletedMessages: !0
                }
            },
            errors: {
                htmlParseError: {
                    ex: e.EXCEPTION
                },
                htmlSnippetError: {
                    ex: e.EXCEPTION
                },
                textChewError: {
                    ex: e.EXCEPTION
                },
                textSnippetError: {
                    ex: e.EXCEPTION
                }
            }
        },
        ActiveSyncFolderSyncer: {
            type: e.DATABASE,
            events: {}
        }
    });
}), define("activesync/jobs", [ "rdcommon/log", "mix", "../jobmixins", "../drafts/jobs", "activesync/codepages/AirSync", "activesync/codepages/Email", "activesync/codepages/Move", "module", "require", "exports" ], function(e, t, n, i, a, o, r, s, c, l) {
    function d(e, t, n) {
        return function() {
            var i = Array.slice(arguments), a = i[e], o = this;
            c([ "wbxml" ], function(e) {
                u || (u = e), o.account.withConnection(a, function() {
                    t.apply(o, i);
                }, n);
            });
        };
    }
    function p(e, t, n) {
        this.account = e, this.resilientServerIds = !0, this._heldMutexReleasers = [], this._LOG = h.ActiveSyncJobDriver(this, n, this.account.id), 
        this._state = t, t.hasOwnProperty("suidToServerId") || (t.suidToServerId = {}, t.moveMap = {}), 
        this._stateDelta = {
            serverIdMap: null,
            moveMap: null
        };
    }
    var u;
    l.ActiveSyncJobDriver = p, p.prototype = {
        postJobCleanup: n.postJobCleanup,
        allJobsDone: n.allJobsDone,
        _accessFolderForMutation: function(e, t, n, i, a) {
            var o = this.account.getFolderStorageForFolderId(e), r = this;
            o.runMutexed(a, function(e) {
                r._heldMutexReleasers.push(e);
                var i = o.folderSyncer;
                if (t) r.account.withConnection(n, function() {
                    try {
                        n(i.folderConn, o);
                    } catch (e) {
                        r._LOG.callbackErr(e);
                    }
                }); else try {
                    n(i.folderConn, o);
                } catch (a) {
                    r._LOG.callbackErr(a);
                }
            });
        },
        _partitionAndAccessFoldersSequentially: n._partitionAndAccessFoldersSequentially,
        local_do_modtags: n.local_do_modtags,
        do_modtags: d(1, function(e, t, n) {
            function i(e) {
                return r && -1 !== r.indexOf(e) ? !0 : s && -1 !== s.indexOf(e) ? !1 : void 0;
            }
            var r = n ? e.removeTags : e.addTags, s = n ? e.addTags : e.removeTags, c = i("\\Seen"), l = i("\\Flagged"), d = a.Tags, p = o.Tags, u = null;
            this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, n, i, a) {
                return n = n.filter(function(e) {
                    return !!e;
                }), n.length ? (e.performMutation(function(e) {
                    for (var t = 0; t < n.length; t++) e.stag(d.Change).tag(d.ServerId, n[t]).stag(d.ApplicationData), 
                    void 0 !== c && e.tag(p.Read, c ? "1" : "0"), void 0 !== l && e.stag(p.Flag).tag(p.Status, l ? "2" : "0").etag(), 
                    e.etag(d.ApplicationData).etag(d.Change);
                }, function(e) {
                    e && (u = e), a();
                }), void 0) : (a(), void 0);
            }, function() {
                t(u);
            }, function() {
                u = "aborted-retry";
            }, n, "modtags");
        }),
        check_modtags: function(e, t) {
            t(null, "idempotent");
        },
        local_undo_modtags: n.local_undo_modtags,
        undo_modtags: function(e, t) {
            this.do_modtags(e, t, !0);
        },
        local_do_move: n.local_do_move,
        do_move: d(1, function(e, t) {
            var n = null, i = this.account, a = this.account.getFolderStorageForFolderId(e.targetFolder), o = r.Tags;
            this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, r, s, c) {
                if (r = r.filter(function(e) {
                    return !!e;
                }), !r.length) return c(), void 0;
                if (r = r.filter(function(e) {
                    return !!e;
                }), !r.length) return c(), void 0;
                var l = new u.Writer("1.3", 1, "UTF-8");
                l.stag(o.MoveItems);
                for (var d = 0; d < r.length; d++) l.stag(o.Move).tag(o.SrcMsgId, r[d]).tag(o.SrcFldId, t.folderMeta.serverId).tag(o.DstFldId, a.folderMeta.serverId).etag(o.Move);
                l.etag(o.MoveItems), i.conn.postCommand(l, function(e) {
                    e && (n = e, console.error("failure moving messages:", e)), c();
                });
            }, function() {
                t(n, null, !0);
            }, function() {
                n = "aborted-retry";
            }, !1, "move");
        }),
        check_move: function() {},
        local_undo_move: n.local_undo_move,
        undo_move: function() {},
        local_do_delete: n.local_do_delete,
        do_delete: d(1, function(e, t) {
            var n = null, i = a.Tags;
            o.Tags, this._partitionAndAccessFoldersSequentially(e.messages, !0, function(e, t, a, o, r) {
                return a = a.filter(function(e) {
                    return !!e;
                }), a.length ? (e.performMutation(function(e) {
                    for (var t = 0; t < a.length; t++) e.stag(i.Delete).tag(i.ServerId, a[t]).etag(i.Delete);
                }, function(e) {
                    e && (n = e, console.error("failure deleting messages:", e)), r();
                }), void 0) : (r(), void 0);
            }, function() {
                t(n, null, !0);
            }, function() {
                n = "aborted-retry";
            }, !1, "delete");
        }),
        check_delete: function(e, t) {
            t(null, "idempotent");
        },
        local_undo_delete: n.local_undo_delete,
        undo_delete: function(e, t) {
            t("moot");
        },
        local_do_syncFolderList: function(e, t) {
            t(null);
        },
        do_syncFolderList: d(1, function(e, t) {
            var n, i = this.account, a = i.getFirstFolderWithType("inbox");
            a && null === a.serverId && (n = i.getFolderStorageForFolderId(a.id)), i.syncFolderList(function(e) {
                e || (i.meta.lastFolderSyncAt = Date.now()), t(e ? "aborted-retry" : null, null, !e), 
                n && n.hasActiveSlices && (e || (console.log("Refreshing fake inbox"), n.resetAndRefreshActiveSlices()));
            });
        }, "aborted-retry"),
        check_syncFolderList: function(e, t) {
            t("idempotent");
        },
        local_undo_syncFolderList: function(e, t) {
            t("moot");
        },
        undo_syncFolderList: function(e, t) {
            t("moot");
        },
        local_do_downloadBodies: n.local_do_downloadBodies,
        do_downloadBodies: n.do_downloadBodies,
        check_downloadBodies: n.check_downloadBodies,
        local_do_downloadBodyReps: n.local_do_downloadBodyReps,
        do_downloadBodyReps: n.do_downloadBodyReps,
        check_downloadBodyReps: n.check_downloadBodyReps,
        local_do_download: n.local_do_download,
        do_download: n.do_download,
        check_download: n.check_download,
        local_undo_download: n.local_undo_download,
        undo_download: n.undo_download,
        local_do_sendOutboxMessages: n.local_do_sendOutboxMessages,
        do_sendOutboxMessages: n.do_sendOutboxMessages,
        check_sendOutboxMessages: n.check_sendOutboxMessages,
        local_undo_sendOutboxMessages: n.local_undo_sendOutboxMessages,
        undo_sendOutboxMessages: n.undo_sendOutboxMessages,
        local_do_setOutboxSyncEnabled: n.local_do_setOutboxSyncEnabled,
        local_do_upgradeDB: n.local_do_upgradeDB,
        local_do_purgeExcessMessages: function(e, t) {
            t(null);
        },
        do_purgeExcessMessages: function(e, t) {
            t(null);
        },
        check_purgeExcessMessages: function() {
            return "idempotent";
        },
        local_undo_purgeExcessMessages: function(e, t) {
            t(null);
        },
        undo_purgeExcessMessages: function(e, t) {
            t(null);
        }
    }, t(p.prototype, i.draftsMixins);
    var h = l.LOGFAB = e.register(s, {
        ActiveSyncJobDriver: {
            type: e.DAEMON,
            events: {
                savedAttachment: {
                    storage: !0,
                    mimeType: !0,
                    size: !0
                },
                saveFailure: {
                    storage: !1,
                    mimeType: !1,
                    error: !1
                }
            },
            TEST_ONLY_events: {
                saveFailure: {
                    filename: !1
                }
            },
            errors: {
                callbackErr: {
                    ex: e.EXCEPTION
                }
            }
        }
    });
}), define("activesync/account", [ "rdcommon/log", "../a64", "../accountmixins", "../mailslice", "../searchfilter", "activesync/codepages/FolderHierarchy", "./folder", "./jobs", "../util", "../db/folder_info_rep", "module", "require", "exports" ], function(e, t, n, i, a, o, r, s, c, l, d, p, u) {
    function h(e, t, n) {
        return function() {
            var i = Array.slice(arguments), a = i[e], o = this;
            this.withConnection(a, function() {
                t.apply(o, i);
            }, n);
        };
    }
    function f(e, t, a, o, c, l) {
        this.universe = e, this.id = t.id, this.accountDef = t, t.connInfo.deviceId || (t.connInfo.deviceId = u.makeUniqueDeviceId()), 
        this._db = o, this._LOG = b.ActiveSyncAccount(this, l, this.id), c ? (this.conn = c, 
        this._attachLoggerToConnection(this.conn)) : this.conn = null, this.enabled = !0, 
        this.problems = [], this._alive = !0, this.identities = t.identities, this.folders = [], 
        this._folderStorages = {}, this._folderInfos = a, this._serverIdToFolderId = {}, 
        this._deadFolderIds = null, this._syncsInProgress = 0, this._lastSyncKey = null, 
        this._lastSyncResponseWasEmpty = !1, this.meta = a.$meta, this.mutations = a.$mutations, 
        this.tzOffset = 0;
        for (var d in a) if ("$" !== d[0]) {
            var p = a[d];
            this._folderStorages[d] = new i.FolderStorage(this, d, p, this._db, r.ActiveSyncFolderSyncer, this._LOG), 
            this._serverIdToFolderId[p.$meta.serverId] = d, this.folders.push(p.$meta);
        }
        this.folders.sort(function(e, t) {
            return e.path.localeCompare(t.path);
        }), this._jobDriver = new s.ActiveSyncJobDriver(this, this._folderInfos.$mutationState), 
        this.ensureEssentialOfflineFolders(), n.accountConstructorMixin.call(this, this, this);
    }
    var m, g, v, _ = c.bsearchForInsert, y = o.Enums.Type, x = u.DEFAULT_TIMEOUT_MS = 3e4;
    u.makeUniqueDeviceId = function() {
        return Math.random().toString(36).substr(2);
    }, u.Account = u.ActiveSyncAccount = f, f.prototype = {
        type: "activesync",
        supportsServerFolders: !0,
        toString: function() {
            return "[ActiveSyncAccount: " + this.id + "]";
        },
        withConnection: function(e, t, n) {
            if (!m) return p([ "wbxml", "activesync/protocol", "activesync/codepages" ], function(i, a, o) {
                m = i, g = a, v = o, this.withConnection(e, t, n);
            }.bind(this)), void 0;
            if (!this.conn) {
                var i = this.accountDef;
                this.conn = new g.Connection(i.connInfo.deviceId), this._attachLoggerToConnection(this.conn), 
                this.conn.open(i.connInfo.server, i.credentials.username, i.credentials.password), 
                this.conn.timeout = x;
            }
            this.conn.connected ? t() : this.conn.connect(function(i) {
                return i ? (this._reportErrorIfNecessary(i), this._isBadUserOrPassError(i) && !n && (n = "bad-user-or-pass"), 
                e(n || "unknown"), void 0) : (t(), void 0);
            }.bind(this));
        },
        _isBadUserOrPassError: function(e) {
            return e && e instanceof g.HttpError && 401 === e.status;
        },
        _reportErrorIfNecessary: function(e) {
            e && this._isBadUserOrPassError(e) && this.universe.__reportAccountProblem(this, "bad-user-or-pass", "incoming");
        },
        _attachLoggerToConnection: function(e) {
            var t = b.ActiveSyncConnection(e, this._LOG, Date.now() % 1e3);
            "safe" === t.logLevel ? e.onmessage = this._onmessage_safe.bind(this, t) : "dangerous" === t.logLevel && (e.onmessage = this._onmessage_dangerous.bind(this, t));
        },
        _onmessage_safe: function(e, t, n, i, a, o, r, s) {
            "options" === t ? e.options(n, i.status, s) : e.command(t, n, i.status);
        },
        _onmessage_dangerous: function(e, t, n, i, a, o, r, s) {
            if ("options" === t) e.options(n, i.status, s); else {
                var c, l;
                if (r) try {
                    var d = new m.Reader(new Uint8Array(r), v);
                    c = d.dump();
                } catch (p) {
                    c = "parse problem";
                }
                if (s) try {
                    l = s.dump(), s.rewind();
                } catch (p) {
                    l = "parse problem";
                }
                e.command(t, n, i.status, a, o, c, l);
            }
        },
        toBridgeWire: function() {
            return {
                id: this.accountDef.id,
                name: this.accountDef.name,
                path: this.accountDef.name,
                type: this.accountDef.type,
                defaultPriority: this.accountDef.defaultPriority,
                enabled: this.enabled,
                problems: this.problems,
                syncRange: this.accountDef.syncRange,
                syncInterval: this.accountDef.syncInterval,
                notifyOnNew: this.accountDef.notifyOnNew,
                playSoundOnSend: this.accountDef.playSoundOnSend,
                identities: this.identities,
                credentials: {
                    username: this.accountDef.credentials.username
                },
                servers: [ {
                    type: this.accountDef.type,
                    connInfo: this.accountDef.connInfo
                } ]
            };
        },
        toBridgeFolder: function() {
            return {
                id: this.accountDef.id,
                name: this.accountDef.name,
                path: this.accountDef.name,
                type: "account"
            };
        },
        get numActiveConns() {
            return 0;
        },
        checkAccount: function(e) {
            null != this.conn && (this.conn.connected && this.conn.disconnect(), this.conn = null), 
            this.withConnection(function(t) {
                e(t);
            }, function() {
                e();
            });
        },
        __checkpointSyncCompleted: function(e, t) {
            this.saveAccountState(null, e, t || "checkpointSync");
        },
        shutdown: function(e) {
            this._LOG.__die(), e && e();
        },
        accountDeleted: function() {
            this._alive = !1, this.shutdown();
        },
        sliceFolderMessages: function(e, t) {
            var n = this._folderStorages[e], a = new i.MailSlice(t, n, this._LOG);
            n.sliceOpenMostRecent(a);
        },
        searchFolderMessages: function(e, t, n, i) {
            var o = this._folderStorages[e], r = new a.SearchSlice(t, o, n, i, this._LOG);
            return o.sliceOpenSearch(r), r;
        },
        syncFolderList: h(0, function(e) {
            var t = this, n = v.FolderHierarchy.Tags, i = new m.Writer("1.3", 1, "UTF-8");
            i.stag(n.FolderSync).tag(n.SyncKey, this.meta.syncKey).etag(), this.conn.postCommand(i, function(i, a) {
                if (i) return t._reportErrorIfNecessary(i), e(i), void 0;
                var o = new m.EventParser(), r = [];
                o.addEventListener([ n.FolderSync, n.SyncKey ], function(e) {
                    t.meta.syncKey = e.children[0].textContent;
                }), o.addEventListener([ n.FolderSync, n.Changes, [ n.Add, n.Delete ] ], function(e) {
                    var i = {};
                    for (var a in Iterator(e.children)) {
                        var o = a[1];
                        i[o.localTagName] = o.children[0].textContent;
                    }
                    e.tag === n.Add ? t._addedFolder(i.ServerId, i.ParentId, i.DisplayName, i.Type) || r.push(i) : t._deletedFolder(i.ServerId);
                });
                try {
                    o.run(a);
                } catch (s) {
                    return console.error("Error parsing FolderSync response:", s, "\n", s.stack), e("unknown"), 
                    void 0;
                }
                for (;r.length; ) {
                    var c = [];
                    for (var l in Iterator(r)) {
                        var d = l[1];
                        t._addedFolder(d.ServerId, d.ParentId, d.DisplayName, d.Type) || c.push(d);
                    }
                    if (c.length === r.length) throw new Error("got some orphaned folders");
                    r = c;
                }
                t.ensureEssentialOnlineFolders(), t.normalizeFolderHierarchy(), console.log("Synced folder list"), 
                e && e(null);
            });
        }),
        _folderTypes: {
            1: "normal",
            2: "inbox",
            3: "drafts",
            4: "trash",
            5: "sent",
            6: "normal",
            12: "normal"
        },
        _addedFolder: function(e, n, a, o, s, c) {
            if (!(s || o in this._folderTypes)) return !0;
            var d = a, p = null, u = 0;
            if ("0" !== n) {
                if (p = this._serverIdToFolderId[n], void 0 === p) return null;
                var h = this._folderInfos[p];
                d = h.$meta.path + "/" + d, u = h.$meta.depth + 1;
            }
            if (o === y.DefaultInbox) {
                var f = this.getFirstFolderWithType("inbox");
                if (f) return delete this._serverIdToFolderId[f.serverId], this._serverIdToFolderId[e] = f.id, 
                f.serverId = e, f.name = a, f.path = d, f.depth = u, f;
            }
            var m = this.id + "/" + t.encodeInt(this.meta.nextFolderNum++), g = this._folderInfos[m] = {
                $meta: l.makeFolderMeta({
                    id: m,
                    serverId: e,
                    name: a,
                    type: s || this._folderTypes[o],
                    path: d,
                    parentId: p,
                    depth: u,
                    lastSyncedAt: 0,
                    syncKey: "0",
                    version: i.FOLDER_DB_VERSION
                }),
                $impl: {
                    nextId: 0,
                    nextHeaderBlock: 0,
                    nextBodyBlock: 0
                },
                accuracy: [],
                headerBlocks: [],
                bodyBlocks: [],
                serverIdHeaderBlockMapping: {}
            };
            console.log("Added folder " + a + " (" + m + ")"), this._folderStorages[m] = new i.FolderStorage(this, m, g, this._db, r.ActiveSyncFolderSyncer, this._LOG), 
            this._serverIdToFolderId[e] = m;
            var v = g.$meta, x = _(this.folders, v, function(e, t) {
                return e.path.localeCompare(t.path);
            });
            return this.folders.splice(x, 0, v), c || this.universe.__notifyAddedFolder(this, v), 
            v;
        },
        _deletedFolder: function(e, t) {
            var n = this._serverIdToFolderId[e], i = this._folderInfos[n], a = i.$meta;
            console.log("Deleted folder " + a.name + " (" + n + ")"), delete this._serverIdToFolderId[e], 
            delete this._folderInfos[n], delete this._folderStorages[n];
            var o = this.folders.indexOf(a);
            this.folders.splice(o, 1), null === this._deadFolderIds && (this._deadFolderIds = []), 
            this._deadFolderIds.push(n), t || this.universe.__notifyRemovedFolder(this, a);
        },
        _recreateFolder: function(e, t) {
            this._LOG.recreateFolder(e);
            var n = this._folderInfos[e];
            n.$impl = {
                nextId: 0,
                nextHeaderBlock: 0,
                nextBodyBlock: 0
            }, n.accuracy = [], n.headerBlocks = [], n.bodyBlocks = [], n.serverIdHeaderBlockMapping = {}, 
            null === this._deadFolderIds && (this._deadFolderIds = []), this._deadFolderIds.push(e);
            var a = this;
            this.saveAccountState(null, function() {
                var o = new i.FolderStorage(a, e, n, a._db, r.ActiveSyncFolderSyncer, a._LOG);
                for (var s in Iterator(a._folderStorages[e]._slices)) {
                    var c = s[1];
                    c._storage = o, c.reset(), o.sliceOpenMostRecent(c);
                }
                a._folderStorages[e]._slices = [], a._folderStorages[e] = o, t(o);
            }, "recreateFolder");
        },
        createFolder: h(3, function(e, t, n, i) {
            var a = this, o = e ? this._folderInfos[e] : "0", r = v.FolderHierarchy.Tags, s = v.FolderHierarchy.Enums.Status, c = v.FolderHierarchy.Enums.Type.Mail, l = new m.Writer("1.3", 1, "UTF-8");
            l.stag(r.FolderCreate).tag(r.SyncKey, this.meta.syncKey).tag(r.ParentId, o).tag(r.DisplayName, t).tag(r.Type, c).etag(), 
            this.conn.postCommand(l, function(e, n) {
                a._reportErrorIfNecessary(e);
                var l, d, p = new m.EventParser();
                p.addEventListener([ r.FolderCreate, r.Status ], function(e) {
                    l = e.children[0].textContent;
                }), p.addEventListener([ r.FolderCreate, r.SyncKey ], function(e) {
                    a.meta.syncKey = e.children[0].textContent;
                }), p.addEventListener([ r.FolderCreate, r.ServerId ], function(e) {
                    d = e.children[0].textContent;
                });
                try {
                    p.run(n);
                } catch (u) {
                    return console.error("Error parsing FolderCreate response:", u, "\n", u.stack), 
                    i("unknown"), void 0;
                }
                if (l === s.Success) {
                    var h = a._addedFolder(d, o, t, c);
                    i(null, h);
                } else l === s.FolderExists ? i("already-exists") : i("unknown");
            });
        }),
        deleteFolder: h(1, function(e, t) {
            var n = this, i = this._folderInfos[e].$meta, a = v.FolderHierarchy.Tags, o = v.FolderHierarchy.Enums.Status;
            v.FolderHierarchy.Enums.Type.Mail;
            var r = new m.Writer("1.3", 1, "UTF-8");
            r.stag(a.FolderDelete).tag(a.SyncKey, this.meta.syncKey).tag(a.ServerId, i.serverId).etag(), 
            this.conn.postCommand(r, function(e, r) {
                n._reportErrorIfNecessary(e);
                var s, c = new m.EventParser();
                c.addEventListener([ a.FolderDelete, a.Status ], function(e) {
                    s = e.children[0].textContent;
                }), c.addEventListener([ a.FolderDelete, a.SyncKey ], function(e) {
                    n.meta.syncKey = e.children[0].textContent;
                });
                try {
                    c.run(r);
                } catch (l) {
                    return console.error("Error parsing FolderDelete response:", l, "\n", l.stack), 
                    t("unknown"), void 0;
                }
                s === o.Success ? (n._deletedFolder(i.serverId), t(null, i)) : t("unknown");
            });
        }),
        sendMessage: h(1, function(e, t) {
            var n = this;
            e.withMessageBlob({
                includeBcc: !0
            }, function(i) {
                if (this.conn.currentVersion.gte("14.0")) {
                    var a = v.ComposeMail.Tags, o = new m.Writer("1.3", 1, "UTF-8", null, "blob");
                    o.stag(a.SendMail).tag(a.ClientId, Date.now().toString() + "@mozgaia").tag(a.SaveInSentItems).stag(a.Mime).opaque(i).etag().etag(), 
                    this.conn.postCommand(o, function(e, i) {
                        return e ? (n._reportErrorIfNecessary(e), console.error(e), t("unknown"), void 0) : (null === i ? (console.log("Sent message successfully!"), 
                        t(null)) : (console.error("Error sending message. XML dump follows:\n" + i.dump()), 
                        t("unknown")), void 0);
                    }, null, null, function() {
                        e.renewSmartWakeLock("ActiveSync XHR Progress");
                    });
                } else this.conn.postData("SendMail", "message/rfc822", i, function(e) {
                    return e ? (n._reportErrorIfNecessary(e), console.error(e), t("unknown"), void 0) : (console.log("Sent message successfully!"), 
                    t(null), void 0);
                }, {
                    SaveInSent: "T"
                }, null, function() {
                    e.renewSmartWakeLock("ActiveSync XHR Progress");
                });
            }.bind(this));
        }),
        getFolderStorageForFolderId: function(e) {
            return this._folderStorages[e];
        },
        getFolderStorageForServerId: function(e) {
            return this._folderStorages[this._serverIdToFolderId[e]];
        },
        getFolderMetaForFolderId: function(e) {
            return this._folderInfos.hasOwnProperty(e) ? this._folderInfos[e].$meta : null;
        },
        ensureEssentialOfflineFolders: function() {
            [ {
                type: "inbox",
                displayName: "Inbox",
                typeNum: y.DefaultInbox
            }, {
                type: "outbox",
                displayName: "outbox",
                typeNum: y.Unknown
            }, {
                type: "localdrafts",
                displayName: "localdrafts",
                typeNum: y.Unknown
            } ].forEach(function(e) {
                this.getFirstFolderWithType(e.type) || this._addedFolder(null, "0", e.displayName, e.typeNum, e.type, !0);
            }, this);
        },
        ensureEssentialOnlineFolders: function(e) {
            e && e();
        },
        normalizeFolderHierarchy: n.normalizeFolderHierarchy,
        scheduleMessagePurge: function(e, t) {
            t && t();
        },
        upgradeFolderStoragesIfNeeded: n.upgradeFolderStoragesIfNeeded,
        runOp: n.runOp,
        getFirstFolderWithType: n.getFirstFolderWithType,
        getFolderByPath: n.getFolderByPath,
        saveAccountState: n.saveAccountState,
        runAfterSaves: n.runAfterSaves,
        allOperationsCompleted: function() {}
    };
    var b = u.LOGFAB = e.register(d, {
        ActiveSyncAccount: {
            type: e.ACCOUNT,
            events: {
                createFolder: {},
                deleteFolder: {},
                recreateFolder: {
                    id: !1
                },
                accountDeleted: {
                    where: !1
                }
            },
            asyncJobs: {
                runOp: {
                    mode: !0,
                    type: !0,
                    error: !0,
                    op: !1
                },
                saveAccountState: {
                    reason: !0,
                    folderSaveCount: !0
                }
            },
            errors: {
                opError: {
                    mode: !1,
                    type: !1,
                    ex: e.EXCEPTION
                }
            }
        },
        ActiveSyncConnection: {
            type: e.CONNECTION,
            events: {
                options: {
                    special: !1,
                    status: !1,
                    result: !1
                },
                command: {
                    name: !1,
                    special: !1,
                    status: !1
                }
            },
            TEST_ONLY_events: {
                options: {},
                command: {
                    params: !1,
                    extraHeaders: !1,
                    sent: !1,
                    response: !1
                }
            }
        }
    });
}), define("activesync/configurator", [ "rdcommon/log", "slog", "../accountcommon", "../a64", "./account", "../date", "tcp-socket", "require", "exports" ], function(e, t, n, i, a, o, r, s, c) {
    function l(e, t) {
        function n(e) {
            if (s) {
                var n = s;
                s = null;
                try {
                    n.close();
                } catch (i) {}
                t(e);
            }
        }
        var i = /^https:\/\/([^:\/]+)(?::(\d+))?/.exec(e);
        if (!i) return t(null), void 0;
        var a = i[2] ? parseInt(i[2], 10) : 443, o = i[1];
        console.log("checking", o, a, "for security problem");
        var s = r.open(o, a);
        s.onopen = function() {
            s.send(new TextEncoder("utf-8").encode("GET /images/logo.png HTTP/1.1\n\n"));
        }, s.onerror = function(e) {
            var t = null;
            e && "object" == typeof e && /^Security/.test(e.name) && (t = "bad-security"), n(t);
        }, s.ondata = function() {
            n(null);
        };
    }
    c.account = a, c.configurator = {
        timeout: 3e4,
        _getFullDetailsFromAutodiscover: function(e, n, i, a) {
            t.log("activesync.configurator.autodiscover:begin", {
                url: i
            }), e.raw_autodiscover(i, n.emailAddress, n.password, self.timeout, !1, function(n, o) {
                if (n) {
                    var r = "no-config-info", s = {};
                    return n instanceof e.HttpError ? 401 === n.status ? r = "bad-user-or-pass" : 403 === n.status ? r = "not-authorized" : s.status = n.status : n instanceof e.AutodiscoverDomainError && t.log("activesync.configurator.autodiscover.error", {
                        message: n.message
                    }), t.log("activesync.configurator.autodiscover:end", {
                        url: i,
                        err: r
                    }), a(r, null, s), void 0;
                }
                t.log("activesync.configurator.autodiscover:end", {
                    url: i,
                    server: o.mobileSyncServer.url
                });
                var c = {
                    type: "activesync",
                    displayName: o.user.name,
                    incoming: {
                        server: o.mobileSyncServer.url,
                        username: o.user.email
                    }
                };
                a(null, c, null);
            });
        },
        tryToCreateAccount: function(e, t, n, i, a) {
            s([ "activesync/protocol" ], function(o) {
                return n.incoming.autodiscoverEndpoint ? (this._getFullDetailsFromAutodiscover(o, t, n.incoming.autodiscoverEndpoint, function(n, r, s) {
                    return n ? (i(n, r, s), void 0) : (this._createAccountUsingFullInfo(e, t, r, i, o, a), 
                    void 0);
                }.bind(this)), void 0) : (this._createAccountUsingFullInfo(e, t, n, i, o, a), void 0);
            }.bind(this));
        },
        _createAccountUsingFullInfo: function(e, n, r, s, c) {
            t.log("activesync.configurator.create:begin", {
                server: r.incoming.server
            });
            var d = {
                username: r.incoming.username,
                password: n.password
            }, p = a.makeUniqueDeviceId(), u = this, h = new c.Connection(p);
            h.open(r.incoming.server, d.username, d.password), h.timeout = a.DEFAULT_TIMEOUT_MS, 
            h.connect(function(a) {
                if (a) {
                    var f, m = {
                        server: r.incoming.server
                    };
                    return a instanceof c.HttpError ? (401 === a.status ? f = "bad-user-or-pass" : 403 === a.status ? f = "not-authorized" : (f = "server-problem", 
                    m.status = a.status), t.log("activesync.configurator.create:end", {
                        server: r.incoming.server,
                        err: f
                    }), s(f, null, m), void 0) : (l(r.incoming.server, function(e) {
                        var t;
                        t = e ? "bad-security" : "unresponsive-server", s(t, null, m);
                    }), void 0);
                }
                var g = i.encodeInt(e.config.nextAccountNum++), v = {
                    id: g,
                    name: n.accountName || n.emailAddress,
                    defaultPriority: o.NOW(),
                    type: "activesync",
                    syncRange: "auto",
                    syncInterval: n.syncInterval || 0,
                    notifyOnNew: n.hasOwnProperty("notifyOnNew") ? n.notifyOnNew : !0,
                    playSoundOnSend: n.hasOwnProperty("playSoundOnSend") ? n.playSoundOnSend : !0,
                    credentials: d,
                    connInfo: {
                        server: r.incoming.server,
                        deviceId: p
                    },
                    identities: [ {
                        id: g + "/" + i.encodeInt(e.config.nextIdentityNum++),
                        name: n.displayName || r.displayName,
                        address: n.emailAddress,
                        replyTo: null,
                        signature: null
                    } ]
                };
                t.log("activesync.configurator.create:end", {
                    server: r.incoming.server,
                    id: g
                }), u._loadAccount(e, v, h, function(e) {
                    s(null, e, null);
                });
            });
        },
        recreateAccount: function(e, t, o, r) {
            var s = o.def, c = {
                username: s.credentials.username,
                password: s.credentials.password
            }, l = i.encodeInt(e.config.nextAccountNum++), d = {
                id: l,
                name: s.name,
                type: "activesync",
                syncRange: s.syncRange,
                syncInterval: s.syncInterval || 0,
                notifyOnNew: s.hasOwnProperty("notifyOnNew") ? s.notifyOnNew : !0,
                playSoundOnSend: s.hasOwnProperty("playSoundOnSend") ? s.playSoundOnSend : !0,
                credentials: c,
                connInfo: {
                    server: s.connInfo.server,
                    deviceId: s.connInfo.deviceId || a.makeUniqueDeviceId()
                },
                identities: n.recreateIdentities(e, l, s.identities)
            };
            this._loadAccount(e, d, null, function(e) {
                r(null, e, null);
            });
        },
        _loadAccount: function(e, t, n, i) {
            var a = {
                $meta: {
                    nextFolderNum: 0,
                    nextMutationNum: 0,
                    lastFolderSyncAt: 0,
                    syncKey: "0"
                },
                $mutations: [],
                $mutationState: {}
            };
            e.saveAccountDef(t, a), e._loadAccount(t, a, n, i);
        }
    };
});