define(["require","exports","module","lib/create-thumbnail-image","debug","views/preview-gallery","lib/prepare-preview-blob","lib/resize-image-and-save","lib/string-utils","lib/bind-all","CustomDialog"],function(e,t,i){function n(e){d(this),this.app=e,this.settings=e.settings,this.dialog=e.dialog||l,this.resizeImageAndSave=c,this.bindEvents(),this.configure(),s("initialized")}var o=e("lib/create-thumbnail-image"),s=e("debug")("controller:preview-gallery"),r=e("views/preview-gallery"),a=e("lib/prepare-preview-blob"),c=e("lib/resize-image-and-save"),h=e("lib/string-utils"),d=e("lib/bind-all"),l=e("CustomDialog");i.exports=function(e){return new n(e)},i.exports.PreviewGalleryController=n,n.prototype.bindEvents=function(){this.app.on("storage:itemdeleted",this.onItemDeleted),this.app.on("preview",this.openPreview),this.app.on("newmedia",this.onNewMedia),this.app.on("hidden",this.onHidden),s("events bound")},n.prototype.configure=function(){this.currentItemIndex=0,this.items=[],this.thumbnailItem=null;var e=window.devicePixelRatio;this.thumbnailSize={width:this.settings.previewGallery.get("thumbnailWidth")*e,height:this.settings.previewGallery.get("thumbnailHeight")*e}},n.prototype.openPreview=function(){if(!this.app.activity.pick&&!this.view){var e=window.CONFIG_MAX_IMAGE_PIXEL_SIZE;this.view=new r,this.view.maxPreviewSize=e,this.view.render().appendTo(this.app.el),this.view.on("click:gallery",this.onGalleryButtonClick),this.view.on("click:share",this.shareCurrentItem),this.view.on("click:delete",this.deleteCurrentItem),this.view.on("click:back",this.closePreview),this.view.on("swipe",this.handleSwipe),this.view.on("click:options",this.onOptionsClick),this.view.on("loadingvideo",this.app.firer("busy")),this.view.on("playingvideo",this.app.firer("ready"));var t=this.app.inSecureMode;this.view.set("secure-mode",t),this.view.open(),this.previewItem(),this.app.emit("previewgallery:opened")}},n.prototype.closePreview=function(){this.thumbnailItem!==this.items[0]&&this.updateThumbnail(),this.view&&(this.currentItemIndex=0,this.view.close(),this.view.destroy(),this.view=null),this.app.emit("previewgallery:closed")},n.prototype.onGalleryButtonClick=function(){if(!this.app.inSecureMode){var e=window.MozActivity;this.mozActivity=new e({name:"browse",data:{type:"photos"}})}},n.prototype.onOptionsClick=function(){this.app.inSecureMode||this.view.showOptionsMenu()},n.prototype.shareCurrentItem=function(){if(!this.app.inSecureMode){var e=this.currentItemIndex,t=this.items[e],i=t.isVideo?"video/*":"image/*",n=h.lastPathComponent(t.filepath),o=function(e){var o=new window.MozActivity({name:"share",data:{type:i,number:1,blobs:[e],filenames:[n],filepaths:[t.filepath]}});o.onerror=function(){console.warn("Share activity error:",o.error.name)}};if(t.isVideo)return o(t.blob),void 0;var s=this;this.stopItemDeletedEvent=!0,this.resizeImageAndSave({blob:t.blob,size:this.settings.activity.get("maxSharePixelSize")},function(e){s.stopItemDeletedEvent=!1,o(e)})}},n.prototype.deleteCurrentItem=function(){function e(){r.hide()}function t(){r.hide(),a.updatePreviewGallery(n),o.isVideo?a.app.emit("previewgallery:deletevideo",s):a.app.emit("previewgallery:deletepicture",s)}if(!this.app.inSecureMode){var i,n=this.currentItemIndex,o=this.items[n],s=o.filepath,r=this.dialog,a=this;i=o.isVideo?navigator.mozL10n.get("delete-video?"):navigator.mozL10n.get("delete-photo?"),r.show("",i,{title:navigator.mozL10n.get("cancel"),callback:e},{title:navigator.mozL10n.get("delete"),callback:t,recommend:!1})}},n.prototype.updatePreviewGallery=function(e){if(this.items.splice(e,1),0===this.items.length)this.closePreview();else{e==this.items.length&&(this.currentItemIndex=this.items.length-1);var t=this.view?!0:!1;t&&this.previewItem()}},n.prototype.handleSwipe=function(e){"left"===e?this.next():"right"===e&&this.previous()},n.prototype.next=function(){this.currentItemIndex<this.items.length-1&&(this.currentItemIndex+=1,this.previewItem())},n.prototype.previous=function(){this.currentItemIndex>0&&(this.currentItemIndex-=1,this.previewItem())},n.prototype.onNewMedia=function(e){function t(e){i.items.unshift(e),i.updateThumbnail()}if(!this.app.activity.pick){var i=this;e.isVideo?t(e):a(e.blob,function(i){i.blob=e.blob,i.filepath=e.filepath,t(i)})}},n.prototype.previewItem=function(){var e=this.currentItemIndex,t=this.items[e];this.view.updateCountText(e+1,this.items.length),t.isVideo?this.view.showVideo(t):this.view.showImage(t)},n.prototype.onItemDeleted=function(e){if(!this.stopItemDeletedEvent){for(var t=-1,i=e.path,n=0;n<this.items.length;n++)if(this.items[n].filepath===i){t=n;break}n!==this.items.length&&this.updatePreviewGallery(t)}},n.prototype.onHidden=function(){this.app.inSecureMode&&(this.configure(),this.updateThumbnail()),this.closePreview()},n.prototype.updateThumbnail=function(){function e(e){i.app.emit("newthumbnail",e)}var t,i=this,n=this.thumbnailItem=this.items[0]||null;if(null===n)return this.app.emit("newthumbnail",null),void 0;if(n.isVideo)t=n.poster.blob;else{if(n.preview){var s=n.width/n.height,r=n.preview.width/n.preview.height;Math.abs(s-r)<.01&&(t=n.blob.slice(n.preview.start,n.preview.end,"image/jpeg"))}t||(t=n.blob)}o(t,n,this.thumbnailSize,e)}});